#include "mainwindow.h"
#ifdef Q_WS_MAEMO_5
#include <QtMaemo5>
#include <QtGui/QX11Info>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
void MainWindow::grabZoomKeys(bool grab)
     {
         if (!winId()) {
             qWarning("Can't grab keys unless we have a window id");
             return;
         }


         unsigned long val = (grab) ? 1 : 0;
         Atom atom = XInternAtom(QX11Info::display(), "_HILDON_ZOOM_KEY_ATOM", False);
         if (!atom) {
             qWarning("Unable to obtain _HILDON_ZOOM_KEY_ATOM. This will only work "
                      "on a Maemo 5 device!");
             return;
         }


         XChangeProperty (QX11Info::display(),
                 winId(),
                 atom,
                 XA_INTEGER,
                 32,
                 PropModeReplace,
                 reinterpret_cast<unsigned char *>(&val),
                 1);
     }
#endif

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{


metaInformationResolver = new Phonon::MediaObject(this);

    ui.setupUi(this);


    scene = new QGraphicsScene;
    ui.graphicsView->setScene(scene);
    QBrush br(Qt::NoBrush);

scene->setForegroundBrush(br);
    scene->setBackgroundBrush(br);

moo = new Phonon::MediaObject;;
device = new Phonon::AudioOutput;
audioPath=Phonon::createPath(moo, device);




//eq
QList<Phonon::EffectDescription> effectDescriptions =
             Phonon::BackendCapabilities::availableAudioEffects();
foreach (Phonon::EffectDescription effectDescription, effectDescriptions)
    {

        if ((effectDescription.name() == "KEqualizer") || (effectDescription.name() == "equalizer-10bands"))
        {
            eqEffect = new Phonon::Effect(effectDescription);

        }
    }

QVBoxLayout* vb = new QVBoxLayout(ui.frame_7);
QHBoxLayout* lt = new QHBoxLayout;
int min=-12,max=12;
for (int i = 0; i < 10; ++i)
{
    QSlider* s = new QSlider (Qt::Vertical);
    s->setMinimum(min);
    s->setMaximum(max);
    s->setMinimumHeight(180);
    s->setValue(0);
    connect (s, SIGNAL(valueChanged(int)), this, SLOT(sliderChanged(int)));
    QVBoxLayout* tmpLay = new QVBoxLayout;
    tmpLay->addWidget(s);
    lt->addLayout(tmpLay);
    sliders.append(s);
}
QCheckBox *enabled = new QCheckBox("Enable equalizer");
enabled->setChecked(false);
connect(enabled, SIGNAL(toggled(bool)), this, SLOT(toggleEqualizer(bool)));
vb->addWidget(enabled);
vb->addLayout(lt);
QPushButton *reset = new QPushButton("Reset sliders");
connect (reset, SIGNAL(clicked()), this, SLOT(resetAll()));
vb->addWidget(reset);
setLayout(vb);


//
slider = new Phonon::SeekSlider(ui.widget_2);
volume=new Phonon::VolumeSlider(ui.widget_2);
ui.verticalLayout_3->addWidget(slider);
ui.verticalLayout_3->addWidget(volume);
slider->setMediaObject(moo);
volume->setAudioOutput(device);

volume->setOrientation(Qt::Horizontal);


opt=new options();
rotate=0;
load();


//opt->load(rotate,ui.listWidget->font().toString(),listWidget->font().pointSize());



mmenu=new QMenu ();
QMenu *mmenut=new QMenu ("Tools");
mmenut->addAction("Download art",this,SLOT(dart()));
mmenut->addAction("Download all art",this,SLOT(dart2()));
mmenu->addAction("Information",this,SLOT(inform()));
mmenu->addMenu(mmenut);
mmenut->addAction("Options",opt,SLOT(exec()));
mmenu->addAction("About",this,SLOT(about()));
mmenu->addAction("Quit",qApp,SLOT(quit()));



connect(ui.pushButton_10,SIGNAL(clicked()),this,SLOT(pl_sf_click()));


connect (opt,SIGNAL(accepted()),this,SLOT(load()));
          connect(metaInformationResolver, SIGNAL(stateChanged(Phonon::State,Phonon::State)), this, SLOT(metaStateChanged(Phonon::State,Phonon::State)));
          connect(ui.pushButton,SIGNAL(clicked()),this,SLOT(click1()));
          connect(ui.pushButton_2,SIGNAL(clicked()),this,SLOT(click2()));
          connect(ui.pushButton_3,SIGNAL(clicked()),this,SLOT(click3()));
          connect(ui.pushButton_4,SIGNAL(clicked()),this,SLOT(click4()));
          connect(ui.pushButton_5,SIGNAL(clicked()),this,SLOT(click5()));
          connect(ui.pushButton_11,SIGNAL(clicked()),this,SLOT(pl_fn_click()));
          connect(ui.pushButton_7,SIGNAL(clicked()),moo,SLOT(pause()));
          connect(ui.pushButton_7,SIGNAL(clicked()),moo,SLOT(stop()));
          connect(ui.pushButton_6,SIGNAL(clicked()),this,SLOT(play_pause()));
          connect (ui.pushButton_8,SIGNAL(clicked()),this,SLOT(prev()));
          connect (ui.pushButton_9,SIGNAL(clicked()),this,SLOT(next()));
          connect(moo,SIGNAL(stateChanged(Phonon::State,Phonon::State)),this,SLOT(changePlay(Phonon::State,Phonon::State)));
          connect(ui.listWidget,SIGNAL(itemDoubleClicked(QListWidgetItem*)),this,SLOT(currentItemChanged(QListWidgetItem*)));
          connect(moo,SIGNAL(finished()),this,SLOT(next()));
          connect (ui.pushButton_12,SIGNAL(clicked()),mmenu,SLOT(show()));
click1();








//new SQLite driven engine
// to test
int row=-1;

     db = QSqlDatabase::addDatabase("QSQLITE");
     db.setDatabaseName("/home/user/tplayer-list");

     if(db.open()){
     QStringList dbtables = db.tables(QSql::Tables);
             if (dbtables.contains( tr("tracks"),
                                    Qt::CaseInsensitive)) {

}else{


    QSqlQuery sql = QSqlQuery(db);
    sql.exec(
                 "create table tracks ( "
                 "  path char(255) not null unique, "
                 "  title char(255) , "
                 "  artist char(255) , "
                 "  genre char(255) , "
                 "  album char(255) , "
                 "  year char(255)  )" );
}
}else{
    QMessageBox::critical(this, QObject::tr("Database Error"),db.lastError().text());
}

reload();
ui.listWidget->setCurrentRow(row);


if (row!=-1)
 moo->setCurrentSource(list.value(ui.listWidget->currentRow()).at(0));





#ifdef Q_WS_MAEMO_5
grabZoomKeys(true);
#endif

#ifdef Q_WS_MAEMO_5
QAbstractKineticScroller *scroller =ui.textEdit->property("kineticScroller").value<QAbstractKineticScroller *>();
scroller->setEnabled(true);
QAbstractKineticScroller *scroller2 =ui.textEdit_2->property("kineticScroller").value<QAbstractKineticScroller *>();
scroller2->setEnabled(true);
#endif

 QList<QWidget *> widgets = this->ui.centralwidget->findChildren<QWidget *>();
for (int i=0;i<widgets.count();i++)
     widgets.at(i)->installEventFilter(this);
}

void MainWindow::reload(){
    QFile file("/home/user/.tplayer-list");
         if (!file.open(QIODevice::ReadOnly | QIODevice::Text)){
           currentQuery="SELECT * FROM tracks WHERE 1";
       }else{
           currentQuery=file.readLine();

           file.close();
       }


QFile file2("/home/user/.tplayer-lists");
   if (file2.open(QIODevice::ReadOnly | QIODevice::Text)){
       while(!file2.atEnd()){
           QString data=file2.readLine();
           autolist.insert(data.split("|").at(0),data.split("|").at(1));
       }
       autolist.remove("#");
       file2.close();
   }

       drawlist();
}



bool MainWindow::eventFilter(QObject *obj, QEvent *event)
{

    if (event->type()==6){
        QKeyEvent *keyEvent = static_cast<QKeyEvent *>(event);


        switch (keyEvent->key()) {
        case Qt::Key_Right:
        next();
        return true;
        break;


        case Qt::Key_Left:
        prev();
       return true;
        break;

        case Qt::Key_Space:
        play_pause();
        return true;
        break;

        case Qt::Key_Z:
        click1();
        return true;
        break;

        case Qt::Key_X:
        click2();
       return true;
        break;

        case Qt::Key_C:
        click3();
        return true;
        break;

        case Qt::Key_V:
        click4();
        return true;
        break;

        case Qt::Key_B:
        click5();
        return true;
        break;

        default: return QObject::eventFilter(obj, event); break;



        }

    } else {
        // standard event processing
        return QObject::eventFilter(obj, event);
    }
}

void MainWindow::keyPressEvent(QKeyEvent* event)
  {

      switch (event->key()) {
      case Qt::Key_F7:
device->setVolume(device->volume()+0.1);
        event->accept();
          break;


      case Qt::Key_F8:
         device->setVolume(device->volume()-0.1);
          event->accept();
          break;

     }





      QWidget::keyPressEvent(event);
  }



void MainWindow::inform(){
QDialog dg;
QString text="Filename : "+moo->currentSource().fileName()+"<br />";
 QMap<QString, QString> metaData = moo->metaData();
 QMapIterator<QString, QString> inf(metaData);
 while(inf.hasNext()){

     text+=inf.next().key()+" : "+inf.value()+"<br />";
 }
QScrollArea tu(&dg);
 QHBoxLayout *fg=new QHBoxLayout(&dg);
 fg->addWidget(&tu);

 QLabel t(QString(text),&tu);
tu.setWidget(&t);

// fg->addWidget(&t);
 t.setTextInteractionFlags(Qt::TextBrowserInteraction|Qt::TextSelectableByMouse);
dg.exec();
}



void MainWindow::sliderChanged (int val){

    QSlider* s = qobject_cast<QSlider*>(sender ());
    if (s)
    {
        int ind = sliders.indexOf(s);
        if (eqEffect)
            {
                double dval = (double)val;
                eqEffect->setParameterValue(eqEffect->parameters()[ind], dval);
            }
    }

}

void MainWindow::resetAll (){
       foreach (QSlider* s, sliders)
       {
s->setValue(0);
       }
}

void MainWindow::toggleEqualizer(bool val)
{
    if (val)
       audioPath.insertEffect(eqEffect);
    else
       audioPath.removeEffect (eqEffect);
}






void MainWindow::load(){

    QFile file("/home/user/.tplayerrc");
            if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
                return;


            QStringList tyu=QString(file.readAll()).split("\n");
            rotate=tyu.at(0).toLong();
            QFont h(tyu.at(1));

            h.setPointSize(tyu.at(2).toLong());
            ui.listWidget->setFont(h);
            namefilter=QString(tyu.at(3)).split(" ");
            if (tyu.count()>4){
scrobler=new last(tyu.at(4),tyu.at(5));

}
            else{
                scrobler=new last("","");

            }

file.close();
#ifdef Q_WS_MAEMO_5
 if (rotate==2){
 this-> setAttribute(Qt::WA_Maemo5AutoOrientation, true);
 }else if(rotate==1){
      setAttribute(Qt::WA_Maemo5PortraitOrientation, true);
  }else{
       setAttribute(Qt::WA_Maemo5LandscapeOrientation, true);
  }
  connect(QApplication::desktop(), SIGNAL(resized(int)), this, SLOT(orientationChanged()));
orientationChanged();
#endif
}

void MainWindow::orientationChanged()
{

    QRect screenGeometry = QApplication::desktop()->screenGeometry();
    /*if (screenGeometry.width() > screenGeometry.height())
    {
        //land
        QHBoxLayout *y=new QHBoxLayout(ui.widget);
        y->addWidget(ui.frame_3);
        y->addWidget(ui.frame);
    }else{
     // port
        QHBoxLayout *y=new QHBoxLayout(ui.widget);
        y->addWidget(ui.frame_3);
        y->addWidget(ui.frame);
    }*/

}

void MainWindow::about(){
    QDialog *dwidget=new QDialog(0);
    QLabel *text=new QLabel("<center><h3>TPlayer</h3></center><br />This program is distributed under terms of GNU GPL v3<br />" \
                            "Source code can be founded at <a href=\"http://googlecode.com/p/tplayer\">http://googlecode.com/p/tplayer</a><br /><br />" \
                            "Lead developer: <bold>Bonapart</bold><br />" \
                            "Web-developer : <bold>[VS]</bold>",dwidget);
    QPushButton *aqt=new QPushButton("AboutQt",dwidget);
    QVBoxLayout *mlay=new QVBoxLayout(dwidget);
    connect(aqt,SIGNAL(clicked()),qApp,SLOT(aboutQt()));
    mlay->addWidget(text);
    mlay->addWidget(aqt);


dwidget->exec();
}

MainWindow::~MainWindow()
{
db.commit();
db.close();
}

void MainWindow::metaStateChanged(Phonon::State newState, Phonon::State /* oldState */)
{
    try{
 loading->setValue(loading->value()+1);

    if (newState == Phonon::ErrorState) {
        QMessageBox::warning(this, tr("Error opening files"),
            metaInformationResolver->errorString());

        queue.removeAt(queue.indexOf(metaInformationResolver->currentSource().fileName()));
        if (queue.count()> 0){

            metaInformationResolver->setCurrentSource(queue.first());

        }else{

                ld->close();
                    drawlist();
                }
        return;
    }

    if (newState != Phonon::StoppedState && newState != Phonon::PausedState)
        return;

    if (metaInformationResolver->currentSource().type() == Phonon::MediaSource::Invalid)
            return;

    QMap<QString, QString> metaData = metaInformationResolver->metaData();

    QString title = metaData.value("TITLE");
    if (title == "")
        title =metaInformationResolver->currentSource().fileName().split("/").last();

QString artist = metaData.value("ARTIST");
    if (artist=="")
        artist="Unknown";

QString album = metaData.value("ALBUM");
if (album=="")
    album="Unknown";
QString year = metaData.value("YEAR");
if (year=="")
    year="Unknown";
QString genre = metaData.value("GENRE");
if (genre=="")
    genre="Unknown";

//list.insert(list.count(),QStringList()<< metaInformationResolver->currentSource().fileName()<<title<<artist<<genre<<album<<year);
QSqlQuery query(db);
QString sq="INSERT INTO tracks (path, title, artist, genre, album, year) "
           "VALUES ("
            "'"+metaInformationResolver->currentSource().fileName()+
            "','"+title+
            "','"+artist+
            "','"+genre+
            "','"+album+
            "','"+year+"')";

query.exec(sq);




queue.removeAt(queue.indexOf(metaInformationResolver->currentSource().fileName()));
if (queue.count() > 0){
    ld->setWindowTitle(queue.first());
        metaInformationResolver->setCurrentSource(queue.first());
    }
else{

    ld->close();
        drawlist();
    }

}catch(int e){
    qDebug(QString("Some error with code : %1").arg(e).toAscii());

}
}



void MainWindow::clear(){
    db.exec("DELETE FROM tracks WHERE 1");
    drawlist();
}





void MainWindow::next(){

    if ((float)moo->currentTime()/(float)moo->totalTime()>0.5)
        scrobler->addTrack(list.value(ui.listWidget->currentRow()),moo->totalTime());

if (ui.listWidget->count()==0)return;
    if (ui.listWidget->currentRow()<ui.listWidget->count()-1)
    ui.listWidget->setCurrentRow(ui.listWidget->currentRow()+1);
    else
        ui.listWidget->setCurrentRow(0);

     moo->setCurrentSource(list.value(ui.listWidget->currentRow()).at(0));
    moo->play();

}

void MainWindow::prev(){
    if (moo->currentTime()/moo->totalTime()>0.5)
        scrobler->addTrack(list.value(ui.listWidget->currentRow()),moo->totalTime());

if (ui.listWidget->count()==0)return;
    if (ui.listWidget->currentRow()>=0)
    ui.listWidget->setCurrentRow(ui.listWidget->currentRow()-1);
    else
        ui.listWidget->setCurrentRow(ui.listWidget->count()-1);

    moo->setCurrentSource(list.value(ui.listWidget->currentRow()).at(0));
    moo->play();

}

void MainWindow::play_pause(){

    if (moo->state()==Phonon::PlayingState )moo->pause();else moo->play();

}

void MainWindow::currentItemChanged ( QListWidgetItem * current ){
    if (moo->currentTime()/moo->totalTime()>0.5)
        scrobler->addTrack(list.value(ui.listWidget->currentRow()),moo->totalTime());

    moo->setCurrentSource(list.value(ui.listWidget->row(current)).at(0));
    moo->play();


}


void MainWindow::changePlay( Phonon::State newstate, Phonon::State oldstate ) {

    if (newstate==Phonon::PlayingState/*&&oldstate!=Phonon::PausedState*/){

scrobler->now(list.value(ui.listWidget->currentRow()),moo->totalTime());


    }

  //  if (newstate==Phonon::PlayingState|| newstate==Phonon::BufferingState ){
    ui.label->setText(list.value(ui.listWidget->currentRow()).at(2)+" - "+list.value(ui.listWidget->currentRow()).at(1));
    this->setWindowTitle(list.value(ui.listWidget->currentRow()).at(2)+" - "+list.value(ui.listWidget->currentRow()).at(1));
#ifdef Q_WS_MAEMO_5
    if (!this->isActiveWindow()){
   QMaemo5InformationBox *box=new QMaemo5InformationBox();
   QLabel *lbl=new QLabel("Now playing :"+list.value(ui.listWidget->currentRow()).at(2)+" - "+list.value(ui.listWidget->currentRow()).at(1),box);
  box->setWidget (lbl);
box->setTimeout(3000);
connect(box,SIGNAL(clicked()),this,SLOT(setFocus()));
box->exec();}
#endif


    QString apath=QString(list.value(ui.listWidget->currentRow()).at(2)).toLower();
    apath.replace("/","");
    QString bpath=QString(apath+" - "+list.value(ui.listWidget->currentRow()).at(4)).toLower();
    bpath.replace("/","");

    QString cpath="/home/user/.covers/";
    scene->clear();

    if (QFileInfo(cpath+bpath+".jpg").exists()){

        QPixmap *t=new QPixmap(cpath+bpath+".jpg");

         scene->addPixmap(t->scaled(ui.graphicsView->width(),ui.graphicsView->height(),Qt::KeepAspectRatio,Qt::FastTransformation));

    }else{
         if (QFileInfo(cpath+apath+".jpg").exists()){

            QPixmap *t=new QPixmap(cpath+apath+".jpg");
             //t= t->scaled(ui.graphicsView->width(),ui.graphicsView->height(),Qt::KeepAspectRatio,Qt::FastTransformation);
             scene->addPixmap(t->scaled(ui.graphicsView->width(),ui.graphicsView->height(),Qt::KeepAspectRatio,Qt::FastTransformation));


         }

}


    QFile file("/home/user/.bios/"+apath+".html");
    if (!file.exists()){
         QUrl url("http://team16.ru/grab.php?bio="+apath);

         QNetworkAccessManager *manager = new QNetworkAccessManager(this);

          connect(manager, SIGNAL(finished(QNetworkReply*)),
                  this, SLOT(replyFinished(QNetworkReply*)));


          manager->get(QNetworkRequest(url));
      }else{
          if (!file.open(QIODevice::ReadOnly|QFile::Text))  return ;

           QTextCodec *codec = QTextCodec::codecForName("UTF-8");

      ui.textEdit->setHtml( codec->toUnicode(file.readAll()));
    //  ui.textEdit->setHtml(file.readAll());
      file.close();
      }
  //}

}

void MainWindow::replyFinished(QNetworkReply*reply){

    QDir g;

    g.mkdir("/home/user/.bios");
    QFile file("/home/user/.bios/"+reply->url().toString().split("=").last()+".html");
        if (!file.open(QIODevice::WriteOnly))  return ;

  QString jk;
  QTextCodec *codec = QTextCodec::codecForName("UTF-8");

  jk=codec->toUnicode(reply->readAll());
  QTextStream out(&file);
        out <<jk;
        file.close();

    if (!file.open(QIODevice::ReadOnly|QFile::Text))  return ;
    QTextCodec *codec2 = QTextCodec::codecForName("UTF-8");
    ui.textEdit->setHtml( codec2->toUnicode(file.readAll()));
    file.close();

}


void MainWindow::dart(){
    QString apath=QString(list.value(ui.listWidget->currentRow()).at(2)).toLower().replace("/","");
    QString bpath=QString(list.value(ui.listWidget->currentRow()).at(4)).toLower().replace("/","");
    QUrl url;
if (list.value(ui.listWidget->currentRow()).at(4)!="Unknown")
    url.setUrl("http://team16.ru/grab.php?image="+apath+"&album="+bpath);
             else
    url.setUrl("http://team16.ru/grab.php?image="+apath);


    QNetworkAccessManager *manager = new QNetworkAccessManager(this);

     connect(manager, SIGNAL(finished(QNetworkReply*)),this, SLOT(replyFinished2(QNetworkReply*)));

     manager->get(QNetworkRequest(url));
}

void MainWindow::dart2(){
    for (int i=0;i<ui.listWidget->count();i++){
        ui.listWidget->setCurrentRow(i);
        dart();
    }
}



void MainWindow::replyFinished2(QNetworkReply*reply){
QByteArray data=reply->readAll();
    QDir g;
    QString fl;
    if (data==QString("404").toAscii()||data==QString("").toAscii()){
        if (reply->url().encodedQueryItems().count()!=1){
            QUrl url("http://team16.ru/grab.php?image="+reply->url().queryItems().at(0).second);
            QNetworkAccessManager *manager = new QNetworkAccessManager(this);

             connect(manager, SIGNAL(finished(QNetworkReply*)),this, SLOT(replyFinished2(QNetworkReply*)));

             manager->get(QNetworkRequest(url));
        }
        return;
    }
    if (reply->url().encodedQueryItems().count()==1)
fl=reply->url().queryItems().at(0).second;
    else
     fl=reply->url().queryItems().at(0).second+" - "+reply->url().queryItems().at(1).second;

    g.mkdir("/home/user/.covers");

    QFile file("/home/user/.covers/"+fl+".jpg");
    if (!file.open(QIODevice::WriteOnly)){
        qDebug(QString::number(file.error()).toAscii());
        return ;}

 file.write(data);
    file.close();



    QString apath=QString(list.value(ui.listWidget->currentRow()).at(2)).toLower().replace("/","");
    QString bpath=QString(apath+" - "+list.value(ui.listWidget->currentRow()).at(4)).toLower().replace("/","");

scene->clear();
    QString cpath="/home/user/.covers/";
    if (QFileInfo(cpath+bpath+".jpg").exists()){

        QPixmap *t=new QPixmap(cpath+bpath+".jpg");
        scene->addPixmap(t->scaled(ui.graphicsView->width(),ui.graphicsView->height(),Qt::KeepAspectRatio,Qt::FastTransformation));

    }else{
         if (QFileInfo(cpath+apath+".jpg").exists()){

            QPixmap *t=new QPixmap(cpath+apath+".jpg");
           scene->addPixmap(t->scaled(ui.graphicsView->width(),ui.graphicsView->height(),Qt::KeepAspectRatio,Qt::FastTransformation));

         }
}
}

void MainWindow::alistload(){
    QAction *t=(QAction *)sender();
currentQuery=autolist.value(t->text());

QFile file("/home/user/.tplayer-list");
     if (!file.open(QIODevice::WriteOnly | QIODevice::Text))
         return;


    file.write(currentQuery.trimmed().toAscii());
    file.close();


drawlist();
}

void MainWindow::pl_sf_click(){
    lmast=new lmaster();
connect(lmast,SIGNAL(accepted()),this,SLOT(reload()));


    tmenu=new QMenu ();
    // autolist
    QMapIterator<QString,QString> item(autolist);
    while (item.hasNext()){
        item.next();
        tmenu->addAction(item.key(),this,SLOT(alistload()));
    }

    //
    tmenu->addSeparator();
    tmenu->addAction("Light master",lmast,SLOT(exec()));



    tmenu->exec(QCursor::pos());





}

void MainWindow::pl_fn_click(){
QMenu fh;
QMenu add("Add");
QMenu mv("Moving");
fh.addMenu(&add);
fh.addMenu(&mv);
//add.addAction("Track",this,SLOT(pl_fn_add_track()));
add.addAction("Directory",this,SLOT(pl_fn_add_dir()));
fh.addAction("Clear",this,SLOT(clear()));
mv.addAction("To begin",ui.listWidget,SLOT(scrollToTop()));
mv.addAction("To end",ui.listWidget,SLOT(scrollToBottom()));
mv.addAction("Find",this,SLOT(find()));
 fh.exec(QCursor::pos());
}



void MainWindow::find(){
    bool ok;
         QString text = QInputDialog::getText(this, tr("Searching "),
                                              tr("Part from name:"), QLineEdit::Normal,
                                              "", &ok);
         if (ok && !text.isEmpty())
         {
             QMapIterator<int,QStringList> i(list);
             while(i.hasNext()){
                 if (i.next().value().join(" ").toLower().indexOf(text.toLower())!=-1){
                     ui.listWidget->setCurrentRow(i.key());
                     return;
                 }
             }
         }
}

void MainWindow::pl_fn_add_dir(){
    int l=0;
    ld=new QDialog();
    loading=new QProgressBar(ld);
    connect(ld,SIGNAL(rejected()),this,SLOT(ch()));
    QHBoxLayout *iu=new QHBoxLayout(ld);
    iu->addWidget(loading);


    QString d;
    QString f=QFileDialog::getExistingDirectory(this,"Tplayer",QDesktopServices::storageLocation(QDesktopServices::MusicLocation),QFileDialog::ReadOnly);
   QApplication::processEvents();

    if (!f.isEmpty())
    {

        ld->setModal(true);
        ld->open();
        loading->setMaximum(100);
        loading->setValue(0);
         loading->show();
QApplication::processEvents();



QDir fg(f);
fg.setFilter(QDir::AllDirs|QDir::Files);
fg.setNameFilters(namefilter);


        QDirIterator it(fg, QDirIterator::Subdirectories|QDirIterator::FollowSymlinks);
        while (it.hasNext()) {
         d=it.next();

         QFileInfo hj(d);
         if (hj.isFile()){
l++;
ld->setWindowTitle(d);
                  getMeta(d);
                  QApplication::processEvents();
              }

    }
    }

    loading->setMaximum(l);
    loading->setValue(0);




    if (l>0){
    metaInformationResolver->setCurrentSource(queue.last());

    }else{

    ld->close();

}



}

void MainWindow::ch(){
    if (loading->value()<loading->maximum())ld->show();
}

void MainWindow::drawlist(){
  //  ld->accept();
    ui.listWidget->clear();
list.clear();

    QSqlQuery query(currentQuery,db);
    int id=0;
    while ( query.next() ) {

        list.insert(id++,QStringList()<<
                    query.value(0).toString()<<
                    query.value(1).toString()<<
                    query.value(2).toString()<<
                    query.value(3).toString()<<
                    query.value(4).toString()<<
                    query.value(5).toString());
         ui.listWidget->addItem(query.value(2).toString()+"-"+query.value(1).toString());

    }

}

void MainWindow::getMeta(QString path){
queue.append(path);
}

void MainWindow::click1(){
    ui.frame_2->show();
    ui.frame_4->hide();
    ui.frame_6->hide();
    ui.frame_7->hide();
    ui.frame_8->hide();

}

void MainWindow::click2(){
    ui.frame_2->hide();
    ui.frame_4->show();
    ui.frame_6->hide();
    ui.frame_7->hide();
    ui.frame_8->hide();
}
void MainWindow::click3(){
    ui.frame_2->hide();
    ui.frame_4->hide();
    ui.frame_6->show();
    ui.frame_7->hide();
    ui.frame_8->hide();
}
void MainWindow::click4(){
    ui.frame_2->hide();
    ui.frame_4->hide();
    ui.frame_6->hide();
    ui.frame_7->hide();
    ui.frame_8->show();
}
void MainWindow::click5(){
    ui.frame_2->hide();
    ui.frame_4->hide();
    ui.frame_6->hide();
    ui.frame_7->show();
    ui.frame_8->hide();
}
